import time
import datetime
import xlsxwriter
import os.path
from src.connection import connection_type as conn

# Get date - 1
# date = datetime.date.today() + datetime.timedelta(days=-1)

# date2 = datetime.date.today()

date = input("Nhập ngày (ví dụ : 31-dec-20) : ")
VERSION_ID = input("Nhập version (Ví dụ : 1887): ") 
start = input("Tháng đầu kỳ (ví dụ : 202001): ")
end = input("Tháng cuối kỳ (ví dụ : 202003): ")

# print(query)
ym = time.strftime("%Y-%m")

def Export_Data(start,end,date,version):
    print("Start Export : {}".format(datetime.datetime.now))

    # Get data to db
    connection = conn.connect_to_oracle_prod_2()
    # Get data to db
    curson = connection.cursor()

    # datef =  date.strftime("%d-%B-%y")
    datef = date

    borrwer_file = r"F:\Data\Accial\Data\Borrwer {} - {}.xlsx ".format(start,end)
    Loan_file = r"F:\Data\Accial\Data\Loan {} - {}.xlsx ".format(start,end)
    Payment_file = r"F:\Data\Accial\Data\Payment {} - {}.xlsx ".format(start,end)
    Schedule_file = r"F:\Data\Accial\Data\Schedule {} - {}.xlsx ".format(start,end)
    Invalid_file = r"F:\Data\Accial\Data\Invalid {} - {}.xlsx ".format(start,end)

    if os.path.exists(borrwer_file):
        os.remove(borrwer_file)

    borrwer_query = "select distinct BORROWER_ID, NAME, SEX, TYPE, BIRTH_DATE, INCOME, INDUSTRY, NUMBER_OF_EMPLOYEES, NUMBER_OF_DEPENDENTS, DATA_DATE, VERSION_ID  from w_accial_borrower where DATA_DATE = '{}' and VERSION_ID = {}".format(datef,version)
    borrwer_data = curson.execute(borrwer_query)
    borrwer_data = curson.fetchall()

    workbook =xlsxwriter.Workbook(borrwer_file,{'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
    worksheet = workbook.add_worksheet("{} - {}".format(start,end))

    # Add a bold format to use to highlight cells.
    bold = workbook.add_format({'bold': 1})

    # Add a number format for cells with money.
    money_format = workbook.add_format({'num_format': '$#,##0'})

    # Add an Excel date format.
    date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

    # Adjust the column width.
    worksheet.set_column(1, 1, 30)

    # Write some data headers.
    worksheet.write(0,0,'BORROWER_ID',bold)
    worksheet.write(0,1,'NAME',bold)
    worksheet.write(0,2,'SEX',bold)
    worksheet.write(0,3,'TYPE',bold)
    worksheet.write(0,4,'BIRTH_DATE',bold)
    worksheet.write(0,5,'INCOME',bold)
    worksheet.write(0,6,'INDUSTRY',bold)
    worksheet.write(0,7,'NUMBER_OF_EMPLOYEES',bold)
    worksheet.write(0,8,'NUMBER_OF_DEPENDENTS',bold)
    worksheet.write(0,9,'DATA_DATE',bold)
    worksheet.write(0,10,'VERSION_ID',bold)

    # Start from the first cell below the headers.
    rowindex = 1
    col = 0
    
    for index in (borrwer_data):
        worksheet.write(rowindex,0,index[0])
        worksheet.write(rowindex,1,index[1])
        worksheet.write(rowindex,2,index[2])
        worksheet.write(rowindex,3,index[3])
        worksheet.write(rowindex,4,index[4])
        worksheet.write(rowindex,5,index[5])
        worksheet.write(rowindex,6,index[6])
        worksheet.write(rowindex,7,index[7])
        worksheet.write(rowindex,8,index[8])
        worksheet.write(rowindex,9,index[9])
        worksheet.write(rowindex,10,index[10])
        rowindex += 1
    workbook.close()

    print(borrwer_query)
    print("Insert Success file Borrwer {} - {}!".format(start,end))

# -------------------------- LOAN FILE ---------------------------------------#

    
    if os.path.exists(Loan_file):
        os.remove(Loan_file)

    loan_query = "select * from w_accial_loan where DATA_DATE = '{}' and VERSION_ID = {}".format(datef,version)
    loan_data = curson.execute(loan_query)
    loan_data = curson.fetchall()

    workbook =xlsxwriter.Workbook(Loan_file,{'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
    worksheet = workbook.add_worksheet("{} - {}".format(start,end))

    # Add a bold format to use to highlight cells.
    bold = workbook.add_format({'bold': 1})

    # Add a number format for cells with money.
    money_format = workbook.add_format({'num_format': '#,##0.00'})

    # Add an Excel date format.
    date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

    # Adjust the column width.
    worksheet.set_column(1, 1, 30)

    worksheet.write(0,0,'LOAN_CODE',bold)
    worksheet.write(0,1,'BORROWER_ID',bold)
    worksheet.write(0,2,'DATE_OF_APPLICATION',bold)
    worksheet.write(0,3,'COLLATERAL',bold)
    worksheet.write(0,4,'COLLATERAL_VALUE',bold)
    worksheet.write(0,5,'RECOVERY_RATE',bold)
    worksheet.write(0,6,'LOAN_ID',bold)
    worksheet.write(0,7,'PRODUCT_TYPE',bold)
    worksheet.write(0,8,'LOAN_GRADE',bold)
    worksheet.write(0,9,'CREDIT_BUREAU_SCORE',bold)
    worksheet.write(0,10,'INTERNAL_SCORE',bold)
    worksheet.write(0,11,'LOAN_AMOUNT',bold)
    worksheet.write(0,12,'INSURRANCEMONEY',bold)
    worksheet.write(0,13,'ADDED_AMOUNT',bold)
    worksheet.write(0,14,'CURRENCY',bold)
    worksheet.write(0,15,'ORIGINATION_FEE',bold)
    worksheet.write(0,16,'DISBURSEMENT_DATE',bold)
    worksheet.write(0,17,'EFFECTIVE_INTEREST_RATE',bold)
    worksheet.write(0,18,'TERM',bold)
    worksheet.write(0,19,'TERM_UNIT',bold)
    worksheet.write(0,20,'FREQUENCY',bold)
    worksheet.write(0,21,'FREQUENCY_UNIT',bold)
    worksheet.write(0,22,'LOAN_TYPE',bold)
    worksheet.write(0,23,'LOAN_STATUS',bold)
    worksheet.write(0,24,'DAYS_PAST_DUE',bold)
    worksheet.write(0,25,'LOANNUMBER',bold)
    worksheet.write(0,26,'ORIGINATOR_AGENT',bold)
    worksheet.write(0,27,'LENDER',bold)
    worksheet.write(0,28,'LOAN_USE',bold)
    worksheet.write(0,29,'RESTRUCTURE_FROM_LOAN_ID',bold)
    worksheet.write(0,30,'RESTRUCTURE_TO_LOAN_ID',bold)
    worksheet.write(0,31,'REFINANCED_FROM_LOAN_ID',bold)
    worksheet.write(0,32,'REFINANCED_TO_LOAN_ID',bold)
    worksheet.write(0,33,'DATA_DATE',bold)
    worksheet.write(0,34,'VERSION_ID',bold)
    worksheet.write(0,35,'SCHEDULE_FLAG',bold)
    worksheet.write(0,36,'STATUS',bold)

    rowindex = 1
    col = 0
    
    for index in (loan_data):
        worksheet.write(rowindex,0,index[0])
        worksheet.write(rowindex,1,index[1])
        worksheet.write(rowindex,2,index[2])
        worksheet.write(rowindex,3,index[3])
        worksheet.write(rowindex,4,index[4])
        worksheet.write(rowindex,5,index[5])
        worksheet.write(rowindex,6,index[6])
        worksheet.write(rowindex,7,index[7])
        worksheet.write(rowindex,8,index[8])
        worksheet.write(rowindex,9,index[9])
        worksheet.write(rowindex,10,index[10])
        worksheet.write(rowindex,11,index[11])
        worksheet.write(rowindex,12,index[12])
        worksheet.write(rowindex,13,index[13])
        worksheet.write(rowindex,14,index[14])
        worksheet.write(rowindex,15,index[15])
        worksheet.write(rowindex,16,index[16])
        worksheet.write(rowindex,17,index[17])
        worksheet.write(rowindex,18,index[18])
        worksheet.write(rowindex,19,index[19])
        worksheet.write(rowindex,20,index[20])
        worksheet.write(rowindex,21,index[21])
        worksheet.write(rowindex,22,index[22])
        worksheet.write(rowindex,23,index[23])
        worksheet.write(rowindex,24,index[24])
        worksheet.write(rowindex,25,index[25])
        worksheet.write(rowindex,26,index[26])
        worksheet.write(rowindex,27,index[27])
        worksheet.write(rowindex,28,index[28])
        worksheet.write(rowindex,29,index[29])
        worksheet.write(rowindex,30,index[30])
        worksheet.write(rowindex,31,index[31])
        worksheet.write(rowindex,32,index[32])
        worksheet.write(rowindex,33,index[33])
        worksheet.write(rowindex,34,index[34])
        worksheet.write(rowindex,35,index[35])
        worksheet.write(rowindex,36,index[36])

        rowindex += 1
    workbook.close()

    print(loan_query)
    print("Insert Success file Loan {} - {} !".format(start,end))


# -------------------------- Payment FILE ---------------------------------------#

    
    if os.path.exists(Payment_file):
        os.remove(Payment_file)

    payment_query = "select distinct LOAN_ID, PAYMENT_ID, ACTUAL_PAYMENT_DATE, ACTUAL_PRINCIPAL, ACTUAL_INTEREST, ACTUAL_OTHER_FEES, ACTUAL_INTEREST_VAT, LATE_FEE, OTHER_CHARGES, DISCOUNT_GIVEN_PRINCIPAL, DISCOUNT_GIVEN_INTERESTS, DISCOUNT_GIVEN_VAT, REFINANCED_AMOUNT, RECOVERED_AMOUNT, PAYMONEY, TIEN_DU, TIEN_DU_KI_TRUOC, INTERESTFEE, FEE_AMOUNT, ENDORSE_FEE, ADMINISTRATIVE_FEE, DATA_DATE, VERSION_ID, LOAN_CODE, DATA_TYPE, ACTUALPROMOTIONMONEY, GIAM_CPV, TIEN_DU_CUOIKY, TIEN_DU_CHITRA, LAI_THANHLY_TS, THU_KHAC, GIAM_PHI_PHAT from w_accial_payment where  VERSION_ID = {}".format(version)
    payment_data = curson.execute(payment_query)
    payment_data = curson.fetchall()

    workbook =xlsxwriter.Workbook(Payment_file,{'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
    worksheet = workbook.add_worksheet("{} - {}".format(start,end))

    # Add a bold format to use to highlight cells.
    bold = workbook.add_format({'bold': 1})

    # Add a number format for cells with money.
    money_format = workbook.add_format({'num_format': '#,##0.00'})

    # Add an Excel date format.
    date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

    # Adjust the column width.
    worksheet.set_column(1, 1, 30)
    worksheet.write(0,0,'LOAN_ID',bold)
    worksheet.write(0,1,'PAYMENT_ID',bold)
    worksheet.write(0,2,'ACTUAL_PAYMENT_DATE',bold)
    worksheet.write(0,3,'ACTUAL_PRINCIPAL',bold)
    worksheet.write(0,4,'ACTUAL_INTEREST',bold)
    worksheet.write(0,5,'ACTUAL_OTHER_FEES',bold)
    worksheet.write(0,6,'ACTUAL_INTEREST_VAT',bold)
    worksheet.write(0,7,'LATE_FEE',bold)
    worksheet.write(0,8,'OTHER_CHARGES',bold)
    worksheet.write(0,9,'DISCOUNT_GIVEN_PRINCIPAL',bold)
    worksheet.write(0,10,'DISCOUNT_GIVEN_INTERESTS',bold)
    worksheet.write(0,11,'DISCOUNT_GIVEN_VAT',bold)
    worksheet.write(0,12,'REFINANCED_AMOUNT',bold)
    worksheet.write(0,13,'RECOVERED_AMOUNT',bold)
    worksheet.write(0,14,'PAYMONEY',bold)
    worksheet.write(0,15,'TIEN_DU',bold)
    worksheet.write(0,16,'TIEN_DU_KI_TRUOC',bold)
    worksheet.write(0,17,'INTERESTFEE',bold)
    worksheet.write(0,18,'FEE_AMOUNT',bold)
    worksheet.write(0,19,'ENDORSE_FEE',bold)
    worksheet.write(0,20,'ADMINISTRATIVE_FEE',bold)
    worksheet.write(0,21,'DATA_DATE',bold)
    worksheet.write(0,22,'VERSION_ID',bold)
    worksheet.write(0,23,'LOAN_CODE',bold)
    worksheet.write(0,24,'DATA_TYPE',bold)
    worksheet.write(0,25,'ACTUALPROMOTIONMONEY',bold)
    worksheet.write(0,26,'GIAM_CPV',bold)
    worksheet.write(0,27,'TIEN_DU_CUOIKY',bold)
    worksheet.write(0,28,'TIEN_DU_CHITRA',bold)
    worksheet.write(0,29,'LAI_THANHLY_TS',bold)
    worksheet.write(0,30,'THU_KHAC',bold)
    worksheet.write(0,31,'GIAM_PHI_PHAT',bold)

    rowindex = 1
    col = 0

    for index in (payment_data):
        worksheet.write(rowindex,0,index[0])
        worksheet.write(rowindex,1,index[1])
        worksheet.write(rowindex,2,index[2])
        worksheet.write(rowindex,3,index[3])
        worksheet.write(rowindex,4,index[4])
        worksheet.write(rowindex,5,index[5])
        worksheet.write(rowindex,6,index[6])
        worksheet.write(rowindex,7,index[7])
        worksheet.write(rowindex,8,index[8])
        worksheet.write(rowindex,9,index[9])
        worksheet.write(rowindex,10,index[10])
        worksheet.write(rowindex,11,index[11])
        worksheet.write(rowindex,12,index[12])
        worksheet.write(rowindex,13,index[13])
        worksheet.write(rowindex,14,index[14])
        worksheet.write(rowindex,15,index[15])
        worksheet.write(rowindex,16,index[16])
        worksheet.write(rowindex,17,index[17])
        worksheet.write(rowindex,18,index[18])
        worksheet.write(rowindex,19,index[19])
        worksheet.write(rowindex,20,index[20])
        worksheet.write(rowindex,21,index[21])
        worksheet.write(rowindex,22,index[22])
        worksheet.write(rowindex,23,index[23])
        worksheet.write(rowindex,24,index[24])
        worksheet.write(rowindex,25,index[25])
        worksheet.write(rowindex,26,index[26])
        worksheet.write(rowindex,27,index[27])
        worksheet.write(rowindex,28,index[28])
        worksheet.write(rowindex,29,index[29])
        worksheet.write(rowindex,30,index[30])
        worksheet.write(rowindex,31,index[31])
        
        rowindex += 1
    workbook.close()

    print(payment_query)
    print("Insert Success file Payment {} - {} !".format(start,end))


# -------------------------- Schedule FILE ---------------------------------------#

    
    if os.path.exists(Schedule_file):
        os.remove(Schedule_file)

    schedule_query = "select distinct LOAN_ID, SCHEDULE_FROM_DATE, SCHEDULED_INSTALLMENT_DATE, SCHEDULED_INSTALLMENT_AMOUNT, SCHEDULED_PRINCIPAL, SCHEDULED_INTEREST, SCHEDULED_OTHER_FEES, SCHEDULED_TAX, PROJECTED_COLLATERAL_VALUE, DATA_DATE, SCHEDULE_FLAG, VERSION_ID from w_accial_schedule where  VERSION_ID = {}".format(version)
    schedule_data = curson.execute(schedule_query)
    schedule_data = curson.fetchall()

    workbook =xlsxwriter.Workbook(Schedule_file,{'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
    worksheet = workbook.add_worksheet("{} - {}".format(start,end))

    # Add a bold format to use to highlight cells.
    bold = workbook.add_format({'bold': 1})

    # Add a number format for cells with money.
    money_format = workbook.add_format({'num_format': '#,##0.00'})

    # Add an Excel date format.
    date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

    worksheet.write(0,0,'LOAN_ID',bold)
    worksheet.write(0,1,'SCHEDULE_FROM_DATE',bold)
    worksheet.write(0,2,'SCHEDULED_INSTALLMENT_DATE',bold)
    worksheet.write(0,3,'SCHEDULED_INSTALLMENT_AMOUNT',bold)
    worksheet.write(0,4,'SCHEDULED_PRINCIPAL',bold)
    worksheet.write(0,5,'SCHEDULED_INTEREST',bold)
    worksheet.write(0,6,'SCHEDULED_OTHER_FEES',bold)
    worksheet.write(0,7,'SCHEDULED_TAX',bold)
    worksheet.write(0,8,'PROJECTED_COLLATERAL_VALUE',bold)
    worksheet.write(0,9,'DATA_DATE',bold)
    worksheet.write(0,10,'SCHEDULE_FLAG',bold)
    worksheet.write(0,11,'VERSION_ID',bold)

    rowindex =1
    rol = 0

    for index in (schedule_data):
        worksheet.write(rowindex,0,index[0])
        worksheet.write(rowindex,1,index[1])
        worksheet.write(rowindex,2,index[2])
        worksheet.write(rowindex,3,index[3])
        worksheet.write(rowindex,4,index[4])
        worksheet.write(rowindex,5,index[5])
        worksheet.write(rowindex,6,index[6])
        worksheet.write(rowindex,7,index[7])
        worksheet.write(rowindex,8,index[8])
        worksheet.write(rowindex,9,index[9])
        worksheet.write(rowindex,10,index[10])
        worksheet.write(rowindex,11,index[11])

        rowindex += 1
    workbook.close()

    print(schedule_query)
    print("Insert Success file Schedule {} - {} !".format(start,end))

    
# -------------------------- Invalid FILE ---------------------------------------#

    
    if os.path.exists(Invalid_file):
        os.remove(Invalid_file)

    invalid_query = "select * from w_accial_invalid where  VERSION_ID = {}".format(version)
    invalid_data = curson.execute(invalid_query)
    invalid_data = curson.fetchall()

    workbook =xlsxwriter.Workbook(Invalid_file,{'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
    worksheet = workbook.add_worksheet("{} - {}".format(start,end))

    # Add a bold format to use to highlight cells.
    bold = workbook.add_format({'bold': 1})

    # Add a number format for cells with money.
    money_format = workbook.add_format({'num_format': '#,##0.00'})

    # Add an Excel date format.
    date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

    worksheet.write(0,0,'DATA_DATE',bold)
    worksheet.write(0,1,'VALIDATION_NUM',bold)
    worksheet.write(0,2,'LOAN_ID',bold)
    worksheet.write(0,3,'LOAN_CODE',bold)
    worksheet.write(0,4,'TOTAL_LOAN_AMOUNT',bold)
    worksheet.write(0,5,'ACTUAL_PRINCIPAL',bold)
    worksheet.write(0,6,'LOAN_AMOUNT',bold)
    worksheet.write(0,7,'COLLATERAL_VALUE',bold)
    worksheet.write(0,8,'FREQUENCY',bold)
    worksheet.write(0,9,'SCHEDULE_COUNT',bold)
    worksheet.write(0,10,'SCHEDULE_PRINCIPAL',bold)
    worksheet.write(0,11,'BORROW_ID',bold)
    worksheet.write(0,12,'DESCRIPTION',bold)
    worksheet.write(0,13,'VERSION_ID',bold)
    worksheet.write(0,14,'BIRTH_DATE',bold)
    worksheet.write(0,15,'PAYMENT_ID',bold)
    worksheet.write(0,16,'TOTAL_ACTUAL_PAYMENT',bold)
    worksheet.write(0,17,'TOTAL_ALLOCATE_PAYMENT',bold)

    rowindex =1
    rol = 0

    for index in (invalid_data):
        worksheet.write(rowindex,0,index[0])
        worksheet.write(rowindex,1,index[1])
        worksheet.write(rowindex,2,index[2])
        worksheet.write(rowindex,3,index[3])
        worksheet.write(rowindex,4,index[4])
        worksheet.write(rowindex,5,index[5])
        worksheet.write(rowindex,6,index[6])
        worksheet.write(rowindex,7,index[7])
        worksheet.write(rowindex,8,index[8])
        worksheet.write(rowindex,9,index[9])
        worksheet.write(rowindex,10,index[10])
        worksheet.write(rowindex,11,index[11])
        worksheet.write(rowindex,12,index[12])
        worksheet.write(rowindex,13,index[13])
        worksheet.write(rowindex,14,index[14])
        worksheet.write(rowindex,15,index[15])
        worksheet.write(rowindex,16,index[16])
        worksheet.write(rowindex,17,index[17])

        rowindex += 1
    workbook.close()

    print(invalid_query)
    print("Insert Success file Invalid {} - {} !".format(start,end))

    print("End export : {}".format(datetime.datetime.now))
    



Export_Data(start,end,date,VERSION_ID)


        

    


    

