import time
import datetime
from src.connection import connection_type as conn
import xlsxwriter
import os.path

# Get date - 1
date = datetime.date.today() + datetime.timedelta(days=-1)

date2 = datetime.date.today()

ym = time.strftime("%Y-%m")
print(ym)

# print(datef)

while date < date2:
    datef = date.strftime("%d-%B-%y")

    query = '''
            with cte as
        (select c.customer_wid, c.customer_code, c.phone_num
            from w_customer_d c
        where 1 = 1
            and length(c.phone_num) > 12),
        customer as
        (select cte.customer_wid,
                cte.customer_code,
                REGEXP_SUBSTR(cte.phone_num, '[^;]+', 1, LEVEL) Phone_
            from cte
        connect by level <= regexp_count(cte.phone_num, ';') + 1)
        select * from customer where length(phone_) > 8
    '''
    print(query)

    print(datef)

    try:
        # Get data to db
        connection = conn.connect_to_oracle_prod_2()
        # Get data to db
        curson = connection.cursor()
        data = curson.execute(query)

        data1 = curson.fetchall()

        FileData = r"C:\Users\F88\Desktop\phone.xlsx"
        if os.path.exists(FileData):
            os.remove(FileData)

        workbook = xlsxwriter.Workbook(FileData, {'default_date_format': 'dd/mm/yyyy', 'constant_memory': True})
        worksheet = workbook.add_worksheet("{}".format(ym))

        # Add a bold format to use to highlight cells.
        bold = workbook.add_format({'bold': 1})

        # Add a number format for cells with money.
        money_format = workbook.add_format({'num_format': '$#,##0'})

        # Add an Excel date format.
        date_format = workbook.add_format({'num_format': 'mmmm d yyyy'})

        # Adjust the column width.
        worksheet.set_column(1, 1, 30)

        # Write some data headers.
        worksheet.write(0, 2, 'CUSTOMER_WID', bold)
        worksheet.write(0, 3, 'CUSTOMER_CODE', bold)
        worksheet.write(0, 4, 'PHONE_', bold)

        # Start from the first cell below the headers.
        rowindex = 1
        col = 0

        for index in (data1):
            worksheet.write(rowindex, 0, index[0])
            worksheet.write(rowindex, 1, index[1])
            worksheet.write(rowindex, 2, index[2])

            rowindex += 1
        workbook.close()

        print("Insert Success khi da co file !")


    except Exception as e:
        print("Lỗi", e)
    finally:
        connection.close()

    date = date + datetime.timedelta(days=+1)
