import datetime

def ETL_KPI_MASTER_REPORT_PROD_2(gg_connection, oracle_connection, sheet_name, data_row, col, year, month):
    """
    Insert Google Sheet to Oracle Table W_KPI_FOR_MASTER_REPORT_A
    :param gg_connection:
    :param oracle_connection:
    :param sheet_name:
    :param data_row:
    :param col:
    :param year:
    :param month:
    :return:
    """
    # get data from google sheet to dataframe
    data = gg_connection.to_dataframe(sheet_name, data_row, col)
    # Đổi tên cột
    data.rename({'PGD': 'PGD', 'STT': 'STT', 'Loại KPI HĐ': 'CATEGORY', 'KPI HĐ': 'KPI_HĐ', 'KPI Dư nợ': 'KPI_Dư_nợ',
                 'Năm KPI': 'Năm_KPI', 'Tháng KPI': 'Tháng_KPI', 'KPI Online lead': 'KPI_Online_lead',
                 'KPI Online Sale': 'KPI_Online_Sale', 'KPI Online Sale (PGD)': 'KPI_Online_Sale_(PGD)',
                 'KPI Online Sale (TLS)': 'KPI_Online_Sale_(TLS)', 'KPI Trade': 'KPI_Trade',
                 'KPI Traffic': 'KPI_Traffic', 'KPI Traffic Trade': 'KPI_Traffic_Trade', 'Tỉnh/TP': 'Tỉnh/TP',
                 'Miền': 'Miền', 'TPK': 'TPK', 'ASM': 'ASM', 'Trade Marketing': 'Trade_Marketing',
                 'Trade Leader': 'Trade_Leader', 'Telesales': 'Telesales', 'Convert kỳ vọng': 'Convert_kỳ_vọng',
                 'Cvs đơn kỳ vọng': 'Cvs_đơn_kỳ_vọng', 'Khu vực': 'Khu_vực', 'Dummy': 'Dummy',
                 'KPI Dư nợ tăng net': 'KPI_NET'}, axis='columns', inplace=True)

    # Fillter dữ liệu cần đồng bộ
    # data_filter = data.loc[(data['Năm_KPI'] ==  str(year)) & (data['Tháng_KPI'] == str(month))  ]
    data_filter = data.loc[(data['Năm_KPI'] == str(year))]
    # # Lọc cột cần lấy
    df = data_filter

    # print(df)
    # Oracle DWH new
    # truncate table
    oracle_cursor = oracle_connection.connection.cursor()
    delete_data = "Delete from W_KPI_FOR_MASTER_REPORT_A where YEAR = {}".format(year)
    oracle_cursor.execute(delete_data)

    for index, row in df.iterrows():
        try:
            x = "INSERT INTO W_KPI_FOR_MASTER_REPORT_A (PGD,CATEGORY,KPI_CONTRACT_NUM,KPI_BALANCE_ATM,YEAR,MONTH,KPI_Online_lead_NUM,KPI_Online_Sale_NUM,KPI_Online_Sale_PGD_NUM,KPI_Online_Sale_TLS_NUM,KPI_Trade_NUM,KPI_Traffic_NUM,KPI_Traffic_Trade_NUM,PROVINCE,AREAR,TPK,ASM,Trade_Marketing,Trade_Leader,Telesales,Convert_kỳ_vọng,Cvs_đơn_kỳ_vọng,REGION,DUMMY,EXTRACT_DT,SHOP_WID,KPI_NET) VALUES('{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}'	 ,'{}','{}','{}','{}')".format(
                row['PGD'], row['CATEGORY'], row['KPI_HĐ'].replace(",", ""), row['KPI_Dư_nợ'].replace(",", ""),
                row['Năm_KPI'], row['Tháng_KPI'], row['KPI_Online_lead'].replace(",", ""),
                row['KPI_Online_Sale'].replace(",", ""), row['KPI_Online_Sale_(PGD)'].replace(",", ""),
                row['KPI_Online_Sale_(TLS)'].replace(",", ""), row['KPI_Trade'].replace(",", ""),
                row['KPI_Traffic'].replace(",", ""), row['KPI_Traffic_Trade'].replace(",", ""), row['Tỉnh/TP'],
                row['Miền'], row['TPK'], row['ASM'], row['Trade_Marketing'], row['Trade_Leader'], row['Telesales'],
                row['Convert_kỳ_vọng'], row['Cvs_đơn_kỳ_vọng'], row['Khu_vực'], row['Dummy'].replace(",", ""),
                datetime.date.today().strftime('%d-%B-%y'), row['Shop ID'], row['KPI_NET'].replace(",", ""))
            # print(x)
            oracle_cursor.execute(x)
        except Exception as err:
            print("Error_ETL_KPI_MASTER_REPORT : '{}'".format(err))
    print("Đồng bộ thành công : ETL_KPI_MASTER_REPORT ")
    oracle_connection.commit()
    oracle_connection.close()