import pandas as pd

def ETL_KPI_FOR_USER_REPOER_A(gg_connection, oracle_connection, sheet_name, data_row, col, ym):
    """
    Insert Google Sheet to Oracle Table W_INS_MAPPING_D
    :param gg_connection:
    :param oracle_connection:
    :param sheet_name:
    :param data_row:
    :param col:
    :param ym:
    :return:
    """
    # get data from google sheet to dataframe
    data = gg_connection.to_dataframe(sheet_name, data_row, col)
    data_filter = data.loc[(data['ym'] == str(ym))]
    # Oracle DWH new
    # truncate table
    oracle_cursor = oracle_connection.connection.cursor()
    delete_data = "Delete from w_kpi_for_user_report_a t where t.ym = '{}'".format(ym)
    oracle_cursor.execute(delete_data)

    for index, row in data_filter.iterrows():
        try:
            tang_net = row['Tăng net'].replace(',', '')
            hdmm_vay = row['HĐMM vay'].replace(',', '')
            doanhthu_baohiem = row['Doanh thu Bảo hiểm'].replace(',', '')
            soxe_cu_mwg = row['Số xe cũ/MWG'].replace(',', '')
            tyle_thu_dunghan = row['Tỉ lệ thu đúng hạn'].replace('%', '')
            tyle_no_qh_phatsinh = row['Tỷ lệ nợ quá hạn phát sinh mới trong kỳ'].replace('%', '')
            kh_moi = row['Số KH mới'].replace(',', '')
            iNPS = row['Điểm iNPS'].replace('%', '')
            LNTT_DPD0 = row['LNTT DPD 0'].replace(',', '')
            tyle_pgd_dat_quymo = row['%PGD đạt quy mô tiêu chuẩn'].replace('%', '')
            tyle_ql_vuottroi = row['%nhân sự quản lý thuộc nhóm Hình mẫu và Vượt trội'].replace('%', '')
            cv_ql_phancong = row['Các công việc khác do quản lý phân công'].replace('%', '')
            ds_gn = row['Doanh số giải ngân'].replace(',', '')

            sql_insert = '''INSERT INTO w_kpi_for_user_report_a(ym,
                                            user_code,
                                            full_name,
                                            role,
                                            shop_code,
                                            shop_nm,
                                            tang_net,
                                            hdmm_vay,
                                            doanh_thu_bao_hiem,
                                            xe_cu_mwg,
                                            tyle_thu_dunghan,
                                            tyle_no_quahan,
                                            kh_moi,
                                            inps,
                                            lntt_dpd0,
                                            tyle_pgd_dat_quymo,
                                            tyle_ql_vuottroi,
                                            cv_khac_phancong,
                                            ds_gn
                                            ) VALUES('{}', '{}', '{}', '{}', '{}', '{}', {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {},{}) '''.format(
                row['ym'], row['Mã NV'], row['Họ và tên'].replace("'", ''), row['Role'], row['Shop_code'], row['PGD'],
                tang_net, hdmm_vay, doanhthu_baohiem, soxe_cu_mwg, tyle_thu_dunghan, tyle_no_qh_phatsinh, kh_moi, iNPS,
                LNTT_DPD0, tyle_pgd_dat_quymo, tyle_ql_vuottroi, cv_ql_phancong, ds_gn)
            oracle_cursor.execute(sql_insert)
            # print(row['ym'] , row['Mã NV'] , row['Họ và tên'] , row['Role'] , row['Shop_code'] , row['PGD']  , tang_net , hdmm_vay , doanhthu_baohiem , soxe_cu_mwg , tyle_thu_dunghan , tyle_no_qh_phatsinh , kh_moi , iNPS , LNTT_DPD0 , tyle_pgd_dat_quymo , tyle_ql_vuottroi , cv_ql_phancong)
            # file_object.write(sql_insert)
            oracle_connection.commit()

        except Exception as err:
            print("Đồng bộ lỗi : '{}'".format(err))
    # file_object.close()
    count = ("Select count(1) from w_kpi_for_user_report_a t where t.ym = '{}'".format(ym))
    result = pd.read_sql(count, oracle_connection)
    print("Số bản ghi được đồng bộ vào bảng w_kpi_for_user_report_a là : " + str(result.iloc[0, 0]))
    oracle_connection.close()
