from abc import ABCMeta, abstractmethod
from src.connection import config_dict
from src.connection import connection_factory


class GGSheetETLTemplate:
    __metaclass__ = ABCMeta
    source = None
    target = None
    cursor = None
    sheet_name = None
    data_row = None
    col = None
    data = None

    def ETL(self):
        self.get_source()
        self.get_target()
        self.get_cursor()
        self.get_data()
        self.insert_to_target()
        self.commit()
        self.close()

    def get_source(self):
        self.source = connection_factory('gg_sheet', config_dict)

    def get_target(self):
        self.target = connection_factory('oracle_dwh', config_dict)

    def get_cursor(self):
        self.cursor = self.target.cursor()

    @abstractmethod
    def delete_data(self):
        pass

    @abstractmethod
    def get_data(self):
        pass

    @abstractmethod
    def insert_to_target(self):
        pass

    def commit(self):
        self.target.commit()

    def close(self):
        # self.source.close()
        self.target.close()
