from abc import ABCMeta, abstractmethod
from src.connection.connection_singleton import Singleton


class RDBMS(Singleton):
    __metaclass__ = ABCMeta
    connection = None
    config = None
    _name = None

    @abstractmethod
    def description(self):
        pass

    def set_config(self, config):
        self.config = config

    def set_connection(self, connection):
        if str(connection) != self._name:
            raise Exception("Sorry, connection type don't match RDMS")
        self.connection = connection

    def cursor(self):
        return self.connection.connection.cursor()

    def connect(self):
        self.connection.connect(self.config)

    def close(self):
        self.connection.connection.close()

    def commit(self):
        self.connection.connection.commit()
