import os
from src.connection import *

###############################################################################
# Factory
###############################################################################


def connection_factory(server, config):
    """Factory Method"""
    connection = None
    if server == 'sql_server':
        connection = SQLServer()
        connection.set_connection(Connect2SQLServer())
        connection.set_config(config['sql_server'])
    elif server == 'oracle_dwh':
        connection = Oracle()
        connection.set_connection(Connect2Oracle())
        connection.set_config(config['oracle'][os.environ['oracle']])
    elif server == 'gg_sheet':
        connection = GGSheet()
        connection.set_connection(Connect2GGSheet())
        connection.set_config(config['gg_sheet'])
    elif server == 'MariaDB':
        connection = MariaDB()
        connection.set_connection(Connect2MariaDB())
        connection.set_config(config['MariaDB'])
    connection.connect()

    return connection
