import pandas as pd
import cx_Oracle
from src.connection.connection_base import RDBMS

###############################################################################
# Connection
###############################################################################


class SQLServer(RDBMS):
    _name = 'SQLServer'

    def description(self):
        print("Connection to SQL Server!")


class Oracle(RDBMS):
    _name = 'Oracle'
    cx_Oracle.init_oracle_client(lib_dir="./src/connection/oracle/instantclient_19_14")

    def description(self):
        print("Connection to Oracle Server!")


class GGSheet(RDBMS):
    _name = 'GGSheet'

    def to_dataframe(self, sheet_name, data_row, col):
        try:
            a = self.connection.connection.worksheet(sheet_name).get_all_values()
            return pd.DataFrame(data=a[data_row:], columns=a[col])
        except Exception as err:
            print(f"Error : '{err}'")

    def description(self):
        print("Connection to Oracle Google Sheet!")


class MariaDB(RDBMS):
    _name = 'MariaDB'

    def description(self):
        print("Connection to MariaDB!")
